20690: Include the nginx snippets pillar, remove unneeded wb1 stuff.
[arvados.git] / tools / salt-install / provision.sh
1 #!/bin/bash
2
3 # Copyright (C) The Arvados Authors. All rights reserved.
4 #
5 # SPDX-License-Identifier: CC-BY-SA-3.0
6
7 # If you want to test arvados in a single host, you can run this script, which
8 # will install it using salt masterless
9 # This script is run by the Vagrant file when you run it with
10 #
11 # vagrant up
12
13 set -eu
14 set -o pipefail
15
16 # capture the directory that the script is running from
17 SCRIPT_DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" >/dev/null 2>&1 && pwd )"
18
19 usage() {
20   echo >&2
21   echo >&2 "Usage: ${0} [-h] [-h]"
22   echo >&2
23   echo >&2 "${0} options:"
24   echo >&2 "  -d, --debug                                 Run salt installation in debug mode"
25   echo >&2 "  -c <local.params>, --config <local.params>  Path to the local.params config file"
26   echo >&2 "  -t, --test                                  Test installation running a CWL workflow"
27   echo >&2 "  -r, --roles                                 List of Arvados roles to apply to the host, comma separated"
28   echo >&2 "                                              Possible values are:"
29   echo >&2 "                                                balancer"
30   echo >&2 "                                                controller"
31   echo >&2 "                                                dispatcher"
32   echo >&2 "                                                keepproxy"
33   echo >&2 "                                                keepbalance"
34   echo >&2 "                                                keepstore"
35   echo >&2 "                                                keepweb"
36   echo >&2 "                                                monitoring"
37   echo >&2 "                                                shell"
38   echo >&2 "                                                webshell"
39   echo >&2 "                                                websocket"
40   echo >&2 "                                                workbench"
41   echo >&2 "                                                workbench2"
42   echo >&2 "                                              Defaults to applying them all"
43   echo >&2 "  -h, --help                                  Display this help and exit"
44   echo >&2 "  --dump-config <dest_dir>                    Dumps the pillars and states to a directory"
45   echo >&2 "                                              This parameter does not perform any installation at all. It's"
46   echo >&2 "                                              intended to give you a parsed set of configuration files so"
47   echo >&2 "                                              you can inspect them or use them in you Saltstack infrastructure."
48   echo >&2 "                                              It"
49   echo >&2 "                                                - parses the pillar and states templates,"
50   echo >&2 "                                                - downloads the helper formulas with their desired versions,"
51   echo >&2 "                                                - prepares the 'top.sls' files both for pillars and states"
52   echo >&2 "                                                  for the selected role(s)"
53   echo >&2 "                                                - writes the resulting files into <dest_dir>"
54   echo >&2 "  -v, --vagrant                               Run in vagrant and use the /vagrant shared dir"
55   echo >&2 "  --development                               Run in dev mode, using snakeoil certs"
56   echo >&2
57 }
58
59 arguments() {
60   # NOTE: This requires GNU getopt (part of the util-linux package on Debian-based distros).
61   if ! which getopt > /dev/null; then
62     echo >&2 "GNU getopt is required to run this script. Please install it and re-reun it"
63     exit 1
64   fi
65
66   TEMP=$(getopt -o c:dhp:r:tv \
67     --long config:,debug,development,dump-config:,help,roles:,test,vagrant \
68     -n "${0}" -- "${@}")
69
70   if [ ${?} != 0 ];
71     then echo "Please check the parameters you entered and re-run again"
72     exit 1
73   fi
74   # Note the quotes around `$TEMP': they are essential!
75   eval set -- "$TEMP"
76
77   while [ ${#} -ge 1 ]; do
78     case ${1} in
79       -c | --config)
80         CONFIG_FILE=${2}
81         shift 2
82         ;;
83       -d | --debug)
84         LOG_LEVEL="debug"
85         shift
86         set -x
87         ;;
88       --dump-config)
89         if [[ ${2} = /* ]]; then
90           DUMP_SALT_CONFIG_DIR=${2}
91         else
92           DUMP_SALT_CONFIG_DIR=${PWD}/${2}
93         fi
94         ## states
95         S_DIR="${DUMP_SALT_CONFIG_DIR}/salt"
96         ## formulas
97         F_DIR="${DUMP_SALT_CONFIG_DIR}/formulas"
98         ## pillars
99         P_DIR="${DUMP_SALT_CONFIG_DIR}/pillars"
100         ## tests
101         T_DIR="${DUMP_SALT_CONFIG_DIR}/tests"
102         DUMP_CONFIG="yes"
103         shift 2
104         ;;
105       --development)
106         DEV_MODE="yes"
107         shift 1
108         ;;
109       -r | --roles)
110         for i in ${2//,/ }
111           do
112             # Verify the role exists
113             if [[ ! "database,balancer,controller,keepstore,websocket,keepweb,workbench2,webshell,keepbalance,keepproxy,shell,workbench,dispatcher,monitoring" == *"$i"* ]]; then
114               echo "The role '${i}' is not a valid role"
115               usage
116               exit 1
117             fi
118             ROLES="${ROLES:-} ${i}"
119           done
120           shift 2
121         ;;
122       -t | --test)
123         TEST="yes"
124         shift
125         ;;
126       -v | --vagrant)
127         VAGRANT="yes"
128         shift
129         ;;
130       --)
131         shift
132         break
133         ;;
134       *)
135         usage
136         exit 1
137         ;;
138     esac
139   done
140 }
141
142 copy_custom_cert() {
143   cert_dir=${1}
144   cert_name=${2}
145
146   mkdir -p --mode=0700 /srv/salt/certs
147
148   if [ -f ${cert_dir}/${cert_name}.crt ]; then
149     install --mode=0600 ${cert_dir}/${cert_name}.crt /srv/salt/certs/arvados-${cert_name}.pem
150   else
151     echo "${cert_dir}/${cert_name}.crt does not exist. Exiting"
152     exit 1
153   fi
154   if [ -f ${cert_dir}/${cert_name}.key ]; then
155     install --mode=0600 ${cert_dir}/${cert_name}.key /srv/salt/certs/arvados-${cert_name}.key
156   else
157     echo "${cert_dir}/${cert_name}.key does not exist. Exiting"
158     exit 1
159   fi
160 }
161
162 apply_var_substitutions() {
163   local SRCFILE=$1
164   local DSTFILE=$2
165   sed "s#__ANONYMOUS_USER_TOKEN__#${ANONYMOUS_USER_TOKEN}#g;
166        s#__BLOB_SIGNING_KEY__#${BLOB_SIGNING_KEY}#g;
167        s#__CONTROLLER_EXT_SSL_PORT__#${CONTROLLER_EXT_SSL_PORT}#g;
168        s#__CLUSTER__#${CLUSTER}#g;
169        s#__DOMAIN__#${DOMAIN}#g;
170        s#__HOSTNAME_EXT__#${HOSTNAME_EXT}#g;
171        s#__IP_INT__#${IP_INT}#g;
172        s#__INITIAL_USER_EMAIL__#${INITIAL_USER_EMAIL}#g;
173        s#__INITIAL_USER_PASSWORD__#${INITIAL_USER_PASSWORD}#g;
174        s#__INITIAL_USER__#${INITIAL_USER}#g;
175        s#__LE_AWS_REGION__#${LE_AWS_REGION:-}#g;
176        s#__LE_AWS_SECRET_ACCESS_KEY__#${LE_AWS_SECRET_ACCESS_KEY:-}#g;
177        s#__LE_AWS_ACCESS_KEY_ID__#${LE_AWS_ACCESS_KEY_ID:-}#g;
178        s#__DATABASE_NAME__#${DATABASE_NAME}#g;
179        s#__DATABASE_USER__#${DATABASE_USER}#g;
180        s#__DATABASE_PASSWORD__#${DATABASE_PASSWORD}#g;
181        s#__DATABASE_INT_IP__#${DATABASE_INT_IP:-}#g;
182        s#__DATABASE_EXTERNAL_SERVICE_HOST_OR_IP__#${DATABASE_EXTERNAL_SERVICE_HOST_OR_IP:-}#g;
183        s#__DATABASE_POSTGRESQL_VERSION__#${DATABASE_POSTGRESQL_VERSION}#g;
184        s#__KEEPWEB_EXT_SSL_PORT__#${KEEPWEB_EXT_SSL_PORT}#g;
185        s#__KEEP_EXT_SSL_PORT__#${KEEP_EXT_SSL_PORT}#g;
186        s#__MANAGEMENT_TOKEN__#${MANAGEMENT_TOKEN}#g;
187        s#__RELEASE__#${RELEASE}#g;
188        s#__SYSTEM_ROOT_TOKEN__#${SYSTEM_ROOT_TOKEN}#g;
189        s#__VERSION__#${VERSION}#g;
190        s#__WEBSHELL_EXT_SSL_PORT__#${WEBSHELL_EXT_SSL_PORT}#g;
191        s#__WEBSOCKET_EXT_SSL_PORT__#${WEBSOCKET_EXT_SSL_PORT}#g;
192        s#__WORKBENCH1_EXT_SSL_PORT__#${WORKBENCH1_EXT_SSL_PORT}#g;
193        s#__WORKBENCH2_EXT_SSL_PORT__#${WORKBENCH2_EXT_SSL_PORT}#g;
194        s#__CLUSTER_INT_CIDR__#${CLUSTER_INT_CIDR}#g;
195        s#__CONTROLLER_INT_IP__#${CONTROLLER_INT_IP}#g;
196        s#__WEBSOCKET_INT_IP__#${WEBSOCKET_INT_IP}#g;
197        s#__KEEP_INT_IP__#${KEEP_INT_IP}#g;
198        s#__KEEPSTORE0_INT_IP__#${KEEPSTORE0_INT_IP}#g;
199        s#__KEEPWEB_INT_IP__#${KEEPWEB_INT_IP}#g;
200        s#__WEBSHELL_INT_IP__#${WEBSHELL_INT_IP}#g;
201        s#__SHELL_INT_IP__#${SHELL_INT_IP}#g;
202        s#__WORKBENCH1_INT_IP__#${WORKBENCH1_INT_IP}#g;
203        s#__WORKBENCH2_INT_IP__#${WORKBENCH2_INT_IP}#g;
204        s#__SSL_KEY_ENCRYPTED__#${SSL_KEY_ENCRYPTED}#g;
205        s#__SSL_KEY_AWS_REGION__#${SSL_KEY_AWS_REGION:-}#g;
206        s#__SSL_KEY_AWS_SECRET_NAME__#${SSL_KEY_AWS_SECRET_NAME}#g;
207        s#__CONTROLLER_MAX_WORKERS__#${CONTROLLER_MAX_WORKERS:-}#g;
208        s#__CONTROLLER_MAX_QUEUED_REQUESTS__#${CONTROLLER_MAX_QUEUED_REQUESTS:-128}#g;
209        s#__MONITORING_USERNAME__#${MONITORING_USERNAME}#g;
210        s#__MONITORING_EMAIL__#${MONITORING_EMAIL}#g;
211        s#__MONITORING_PASSWORD__#${MONITORING_PASSWORD}#g;
212        s#__DISPATCHER_SSH_PRIVKEY__#${DISPATCHER_SSH_PRIVKEY//$'\n'/\\n}#g;
213        s#__ENABLE_BALANCER__#${ENABLE_BALANCER}#g;
214        s#__DISABLED_CONTROLLER__#${DISABLED_CONTROLLER}#g;
215        s#__BALANCER_NODENAME__#${ROLE2NODES['balancer']:-}#g;
216        s#__PROMETHEUS_NODENAME__#${ROLE2NODES['monitoring']:-}#g;
217        s#__PROMETHEUS_DATA_RETENTION_TIME__#${PROMETHEUS_DATA_RETENTION_TIME:-15d}#g;
218        s#__CONTROLLER_NODES__#${ROLE2NODES['controller']:-}#g;
219        s#__NODELIST__#${NODELIST}#g;
220        s#__DISPATCHER_INT_IP__#${DISPATCHER_INT_IP}#g;
221        s#__KEEPBALANCE_INT_IP__#${KEEPBALANCE_INT_IP}#g;
222        s#__COMPUTE_AMI__#${COMPUTE_AMI:-}#g;
223        s#__COMPUTE_SG__#${COMPUTE_SG:-}#g;
224        s#__COMPUTE_SUBNET__#${COMPUTE_SUBNET:-}#g;
225        s#__COMPUTE_AWS_REGION__#${COMPUTE_AWS_REGION:-}#g;
226        s#__COMPUTE_USER__#${COMPUTE_USER:-}#g;
227        s#__KEEP_AWS_S3_BUCKET__#${KEEP_AWS_S3_BUCKET:-}#g;
228        s#__KEEP_AWS_IAM_ROLE__#${KEEP_AWS_IAM_ROLE:-}#g;
229        s#__KEEP_AWS_REGION__#${KEEP_AWS_REGION:-}#g" \
230   "${SRCFILE}" > "${DSTFILE}"
231 }
232
233 DEV_MODE="no"
234 CONFIG_FILE="${SCRIPT_DIR}/local.params"
235 CONFIG_DIR="local_config_dir"
236 DUMP_CONFIG="no"
237 LOG_LEVEL="info"
238 CONTROLLER_EXT_SSL_PORT=443
239 TESTS_DIR="tests"
240
241 NGINX_INSTALL_SOURCE="install_from_repo"
242
243 CLUSTER=""
244 DOMAIN=""
245
246 # Hostnames/IPs used for single-host deploys
247 IP_INT="127.0.1.1"
248
249 # Initial user setup
250 INITIAL_USER=""
251 INITIAL_USER_EMAIL=""
252 INITIAL_USER_PASSWORD=""
253
254 CONTROLLER_EXT_SSL_PORT=8000
255 KEEP_EXT_SSL_PORT=25101
256 # Both for collections and downloads
257 KEEPWEB_EXT_SSL_PORT=9002
258 WEBSHELL_EXT_SSL_PORT=4202
259 WEBSOCKET_EXT_SSL_PORT=8002
260 WORKBENCH1_EXT_SSL_PORT=443
261 WORKBENCH2_EXT_SSL_PORT=3001
262
263 SSL_MODE="self-signed"
264 USE_LETSENCRYPT_ROUTE53="no"
265 CUSTOM_CERTS_DIR="${SCRIPT_DIR}/local_config_dir/certs"
266
267 GRAFANA_DASHBOARDS_DIR="${SCRIPT_DIR}/local_config_dir/dashboards"
268
269 ## These are ARVADOS-related parameters
270 # For a stable release, change RELEASE "production" and VERSION to the
271 # package version (including the iteration, e.g. X.Y.Z-1) of the
272 # release.
273 # The "local.params.example.*" files already set "RELEASE=production"
274 # to deploy  production-ready packages
275 RELEASE="development"
276 VERSION="latest"
277
278 # These are arvados-formula-related parameters
279 # An arvados-formula tag. For a stable release, this should be a
280 # branch name (e.g. X.Y-dev) or tag for the release.
281 # ARVADOS_TAG="2.2.0"
282 # BRANCH="main"
283
284 # We pin the salt version to avoid potential incompatibilities when a new
285 # stable version is released.
286 SALT_VERSION="3004"
287
288 # Other formula versions we depend on
289 #POSTGRES_TAG="v0.44.0"
290 #POSTGRES_URL="https://github.com/saltstack-formulas/postgres-formula.git"
291 POSTGRES_TAG="0.45.0-bugfix327"
292 POSTGRES_URL="https://github.com/arvados/postgres-formula.git"
293 NGINX_TAG="v2.8.1"
294 DOCKER_TAG="v2.4.2"
295 LOCALE_TAG="v0.3.4"
296 LETSENCRYPT_TAG="v2.1.0"
297 LOGROTATE_TAG="v0.14.0"
298 PROMETHEUS_TAG="v5.6.5"
299 GRAFANA_TAG="v3.1.3"
300
301 # Salt's dir
302 DUMP_SALT_CONFIG_DIR=""
303 ## states
304 S_DIR="/srv/salt"
305 STATES_TOP=${S_DIR}/top.sls
306 ## formulas
307 F_DIR="/srv/formulas"
308 ## pillars
309 P_DIR="/srv/pillars"
310 PILLARS_TOP=${P_DIR}/top.sls
311 ## tests
312 T_DIR="/tmp/cluster_tests"
313
314 arguments ${@}
315
316 declare -A NODES
317 declare -A ROLE2NODES
318 declare NODELIST
319
320 source common.sh
321
322 if [ ! -d ${CONFIG_DIR} ]; then
323   echo >&2 "You don't seem to have a config directory with pillars and states."
324   echo >&2 "Please create a '${CONFIG_DIR}' directory (as configured in your '${CONFIG_FILE}'). Please see"
325   echo >&2 "  * https://doc.arvados.org/install/salt-single-host.html#single_host, or"
326   echo >&2 "  * https://doc.arvados.org/install/salt-multi-host.html#multi_host_multi_hostnames"
327   exit 1
328 fi
329
330 if grep -rni 'fixme' ${CONFIG_FILE}.secrets ${CONFIG_FILE} ${CONFIG_DIR} ; then
331   echo >&2 "The config files has some parameters that need to be modified."
332   echo >&2 "Please, fix them and re-run the provision script."
333   exit 1
334 fi
335
336 if ! grep -qE '^[[:alnum:]]{5}$' <<<${CLUSTER} ; then
337   echo >&2 "ERROR: <CLUSTER> must be exactly 5 lowercase alphanumeric characters long"
338   echo >&2 "Fix the cluster name in the 'local.params' file and re-run the provision script"
339   exit 1
340 fi
341
342 # Only used in single_host/single_name deploys
343 if [ ! -z "${HOSTNAME_EXT:-}" ] ; then
344   # We need to add some extra control vars to manage a single certificate vs. multiple
345   USE_SINGLE_HOSTNAME="yes"
346   # Make sure that the value configured as IP_INT is a real IP on the system.
347   # If we don't error out early here when there is a mismatch, the formula will
348   # fail with hard to interpret nginx errors later on.
349   ip addr list |grep "${IP_INT}/" >/dev/null
350   if [[ $? -ne 0 ]]; then
351     echo "Unable to find the IP_INT address '${IP_INT}' on the system, please correct the value in local.params. Exiting..."
352     exit 1
353   fi
354 else
355   USE_SINGLE_HOSTNAME="no"
356   # We set this variable, anyway, so sed lines do not fail and we don't need to add more
357   # conditionals
358   HOSTNAME_EXT="${DOMAIN}"
359 fi
360
361 if [ "${DUMP_CONFIG}" = "yes" ]; then
362   echo "The provision installer will just dump a config under ${DUMP_SALT_CONFIG_DIR} and exit"
363 else
364   # Install a few dependency packages
365   # First, let's figure out the OS we're working on
366   OS_ID=$(grep ^ID= /etc/os-release |cut -f 2 -d=  |cut -f 2 -d \")
367   echo "Detected distro: ${OS_ID}"
368
369   case ${OS_ID} in
370     "centos")
371       echo "WARNING! Disabling SELinux, see https://dev.arvados.org/issues/18019"
372       sed -i 's/SELINUX=enforcing/SELINUX=permissive/g' /etc/sysconfig/selinux
373       setenforce permissive
374       yum install -y  curl git jq
375       ;;
376     "debian"|"ubuntu")
377       # Wait 2 minutes for any apt locks to clear
378       # This option is supported from apt 1.9.1 and ignored in older apt versions.
379       # Cf. https://blog.sinjakli.co.uk/2021/10/25/waiting-for-apt-locks-without-the-hacky-bash-scripts/
380       DEBIAN_FRONTEND=noninteractive apt -o DPkg::Lock::Timeout=120 update
381       DEBIAN_FRONTEND=noninteractive apt install -y curl git jq
382       ;;
383   esac
384
385   if which salt-call; then
386     echo "Salt already installed"
387   else
388     curl -L https://bootstrap.saltstack.com -o /tmp/bootstrap_salt.sh
389     sh /tmp/bootstrap_salt.sh -XdfP -x python3 old-stable ${SALT_VERSION}
390     /bin/systemctl stop salt-minion.service
391     /bin/systemctl disable salt-minion.service
392   fi
393
394   # Set salt to masterless mode
395   cat > /etc/salt/minion << EOFSM
396 failhard: "True"
397
398 file_client: local
399 file_roots:
400   base:
401     - ${S_DIR}
402     - ${F_DIR}/*
403
404 pillar_roots:
405   base:
406     - ${P_DIR}
407 EOFSM
408 fi
409
410 mkdir -p ${S_DIR} ${F_DIR} ${P_DIR} ${T_DIR}
411
412 # Get the formula and dependencies
413 cd ${F_DIR} || exit 1
414 echo "Cloning formulas"
415 test -d docker && ( cd docker && git fetch ) \
416   || git clone --quiet https://github.com/saltstack-formulas/docker-formula.git ${F_DIR}/docker
417 ( cd docker && git checkout --quiet tags/"${DOCKER_TAG}" )
418
419 echo "...locale"
420 test -d locale && ( cd locale && git fetch ) \
421   || git clone --quiet https://github.com/saltstack-formulas/locale-formula.git ${F_DIR}/locale
422 ( cd locale && git checkout --quiet tags/"${LOCALE_TAG}" )
423
424 echo "...nginx"
425 test -d nginx && ( cd nginx && git fetch ) \
426   || git clone --quiet https://github.com/saltstack-formulas/nginx-formula.git ${F_DIR}/nginx
427 ( cd nginx && git checkout --quiet tags/"${NGINX_TAG}" )
428
429 echo "...postgres"
430 test -d postgres && ( cd postgres && git fetch ) \
431   || git clone --quiet ${POSTGRES_URL} ${F_DIR}/postgres
432 ( cd postgres && git checkout --quiet tags/"${POSTGRES_TAG}" )
433
434 echo "...prometheus"
435 test -d prometheus && ( cd prometheus && git fetch ) \
436   || git clone --quiet https://github.com/saltstack-formulas/prometheus-formula.git ${F_DIR}/prometheus
437 ( cd prometheus && git checkout --quiet tags/"${PROMETHEUS_TAG}" )
438
439 echo "...grafana"
440 test -d grafana && ( cd grafana && git fetch ) \
441   || git clone --quiet https://github.com/saltstack-formulas/grafana-formula.git ${F_DIR}/grafana
442 ( cd grafana && git checkout --quiet "${GRAFANA_TAG}" )
443
444 echo "...letsencrypt"
445 test -d letsencrypt && ( cd letsencrypt && git fetch ) \
446   || git clone --quiet https://github.com/saltstack-formulas/letsencrypt-formula.git ${F_DIR}/letsencrypt
447 ( cd letsencrypt && git checkout --quiet tags/"${LETSENCRYPT_TAG}" )
448
449 echo "...logrotate"
450 test -d logrotate && ( cd logrotate && git fetch ) \
451   || git clone --quiet https://github.com/saltstack-formulas/logrotate-formula.git ${F_DIR}/logrotate
452 ( cd logrotate && git checkout --quiet tags/"${LOGROTATE_TAG}" )
453
454 echo "...arvados"
455 test -d arvados || git clone --quiet https://git.arvados.org/arvados-formula.git ${F_DIR}/arvados
456
457 # If we want to try a specific branch of the formula
458 if [[ ! -z "${BRANCH:-}" && "x${BRANCH}" != "xmain" ]]; then
459   ( cd ${F_DIR}/arvados && git fetch && git checkout --quiet "${BRANCH}" || git checkout --quiet -t origin/"${BRANCH}" -b "${BRANCH}" )
460 elif [ "x${ARVADOS_TAG:-}" != "x" ]; then
461   ( cd ${F_DIR}/arvados && git checkout --quiet tags/"${ARVADOS_TAG}" -b "${ARVADOS_TAG}" )
462 fi
463
464 if [ "x${VAGRANT:-}" = "xyes" ]; then
465   EXTRA_STATES_DIR="/home/vagrant/${CONFIG_DIR}/states"
466   SOURCE_PILLARS_DIR="/home/vagrant/${CONFIG_DIR}/pillars"
467   SOURCE_TOFS_DIR="/home/vagrant/${CONFIG_DIR}/tofs"
468   SOURCE_TESTS_DIR="/home/vagrant/${TESTS_DIR}"
469 else
470   EXTRA_STATES_DIR="${SCRIPT_DIR}/${CONFIG_DIR}/states"
471   SOURCE_PILLARS_DIR="${SCRIPT_DIR}/${CONFIG_DIR}/pillars"
472   SOURCE_TOFS_DIR="${SCRIPT_DIR}/${CONFIG_DIR}/tofs"
473   SOURCE_TESTS_DIR="${SCRIPT_DIR}/${TESTS_DIR}"
474 fi
475
476 SOURCE_STATES_DIR="${EXTRA_STATES_DIR}"
477
478 echo "Writing pillars and states"
479
480 # Replace variables (cluster,  domain, etc) in the pillars, states and tests
481 # to ease deployment for newcomers
482 if [ ! -d "${SOURCE_PILLARS_DIR}" ]; then
483   echo "${SOURCE_PILLARS_DIR} does not exist or is not a directory. Exiting."
484   exit 1
485 fi
486 for f in $(ls "${SOURCE_PILLARS_DIR}"/*); do
487   apply_var_substitutions "${f}" "${P_DIR}"/$(basename "${f}")
488 done
489
490 if [ ! -d "${SOURCE_TESTS_DIR}" ]; then
491   echo "WARNING: The tests directory was not copied to \"${SOURCE_TESTS_DIR}\"."
492   if [ "x${TEST:-}" = "xyes" ]; then
493     echo "WARNING: Disabling tests for this installation."
494   fi
495   TEST="no"
496 else
497   mkdir -p ${T_DIR}
498   # Replace cluster and domain name in the test files
499   for f in $(ls "${SOURCE_TESTS_DIR}"/*); do
500     FILTERS="s#__CLUSTER__#${CLUSTER}#g;
501          s#__CONTROLLER_EXT_SSL_PORT__#${CONTROLLER_EXT_SSL_PORT}#g;
502          s#__DOMAIN__#${DOMAIN}#g;
503          s#__IP_INT__#${IP_INT}#g;
504          s#__INITIAL_USER_EMAIL__#${INITIAL_USER_EMAIL}#g;
505          s#__INITIAL_USER_PASSWORD__#${INITIAL_USER_PASSWORD}#g
506          s#__INITIAL_USER__#${INITIAL_USER}#g;
507          s#__DATABASE_PASSWORD__#${DATABASE_PASSWORD}#g;
508          s#__SYSTEM_ROOT_TOKEN__#${SYSTEM_ROOT_TOKEN}#g"
509     if [ "$USE_SINGLE_HOSTNAME" = "yes" ]; then
510       FILTERS="s#__CLUSTER__.__DOMAIN__#${HOSTNAME_EXT}#g;
511          $FILTERS"
512     fi
513     sed "$FILTERS" \
514       "${f}" > ${T_DIR}/$(basename "${f}")
515   done
516   chmod 755 ${T_DIR}/run-test.sh
517 fi
518
519 # Replace helper state files that differ from the formula's examples
520 if [ -d "${SOURCE_STATES_DIR}" ]; then
521   mkdir -p "${F_DIR}"/extra/extra
522   rm -rf "${F_DIR}"/extra/extra/*
523
524   for f in $(ls "${SOURCE_STATES_DIR}"/*); do
525     apply_var_substitutions "${f}" "${F_DIR}/extra/extra"/$(basename "${f}")
526   done
527 fi
528
529 # Now, we build the SALT states/pillars trees
530 # As we need to separate both states and pillars in case we want specific
531 # roles, we iterate on both at the same time
532
533 # Formula template overrides (TOFS)
534 # See: https://template-formula.readthedocs.io/en/latest/TOFS_pattern.html#template-override
535 if [ -d ${SOURCE_TOFS_DIR} ]; then
536   find ${SOURCE_TOFS_DIR} -mindepth 1 -maxdepth 1 -type d -exec cp -r "{}" ${S_DIR} \;
537 fi
538
539 # States
540 cat > ${STATES_TOP} << EOFTSLS
541 base:
542   '*':
543     - locale
544 EOFTSLS
545
546 # Pillars
547 cat > ${PILLARS_TOP} << EOFPSLS
548 base:
549   '*':
550     - locale
551     - arvados
552 EOFPSLS
553
554 # States, extra states
555 if [ -d "${F_DIR}"/extra/extra ]; then
556   SKIP_SNAKE_OIL="snakeoil_certs"
557
558   if [[ "$DEV_MODE" = "yes" || "${SSL_MODE}" == "self-signed" ]] ; then
559     # In dev mode, we create some snake oil certs that we'll
560     # use as CUSTOM_CERTS, so we don't skip the states file.
561     # Same when using self-signed certificates.
562     SKIP_SNAKE_OIL="dont_add_snakeoil_certs"
563   fi
564   for f in $(ls "${F_DIR}"/extra/extra/*.sls | egrep -v "${SKIP_SNAKE_OIL}|shell_"); do
565   echo "    - extra.$(basename ${f} | sed 's/.sls$//g')" >> ${STATES_TOP}
566   done
567   # Use byo or self-signed certificates
568   if [ "${SSL_MODE}" != "lets-encrypt" ]; then
569     mkdir -p "${F_DIR}"/extra/extra/files
570   fi
571 fi
572
573 # If we want specific roles for a node, just add the desired states
574 # and its dependencies
575 if [ -z "${ROLES:-}" ]; then
576   # States
577   echo "    - nginx.passenger" >> ${STATES_TOP}
578   if [ "${SSL_MODE}" = "lets-encrypt" ]; then
579     if [ "${USE_LETSENCRYPT_ROUTE53}" = "yes" ]; then
580       grep -q "aws_credentials" ${STATES_TOP} || echo "    - extra.aws_credentials" >> ${STATES_TOP}
581     fi
582     grep -q "letsencrypt" ${STATES_TOP} || echo "    - letsencrypt" >> ${STATES_TOP}
583   else
584     mkdir -p --mode=0700 /srv/salt/certs
585     if [ "${SSL_MODE}" = "bring-your-own" ]; then
586       # Copy certs to formula extra/files
587       install --mode=0600 ${CUSTOM_CERTS_DIR}/* /srv/salt/certs/
588       # We add the custom_certs state
589       grep -q "custom_certs" ${STATES_TOP} || echo "    - extra.custom_certs" >> ${STATES_TOP}
590       if [ "${SSL_KEY_ENCRYPTED}" = "yes" ]; then
591         grep -q "ssl_key_encrypted" ${STATES_TOP} || echo "    - extra.ssl_key_encrypted" >> ${STATES_TOP}
592       fi
593     fi
594     # In self-signed mode, the certificate files will be created and put in the
595     # destination directory by the snakeoil_certs.sls state file
596   fi
597
598   echo "    - postgres" >> ${STATES_TOP}
599   echo "    - logrotate" >> ${STATES_TOP}
600   echo "    - docker.software" >> ${STATES_TOP}
601   echo "    - arvados" >> ${STATES_TOP}
602   echo "    - extra.shell_sudo_passwordless" >> ${STATES_TOP}
603   echo "    - extra.shell_cron_add_login_sync" >> ${STATES_TOP}
604   echo "    - extra.passenger_rvm" >> ${STATES_TOP}
605
606   # Pillars
607   echo "    - docker" >> ${PILLARS_TOP}
608   echo "    - nginx_api_configuration" >> ${PILLARS_TOP}
609   echo "    - logrotate_api" >> ${PILLARS_TOP}
610   echo "    - nginx_controller_configuration" >> ${PILLARS_TOP}
611   echo "    - nginx_keepproxy_configuration" >> ${PILLARS_TOP}
612   echo "    - nginx_keepweb_configuration" >> ${PILLARS_TOP}
613   echo "    - nginx_passenger" >> ${PILLARS_TOP}
614   echo "    - nginx_websocket_configuration" >> ${PILLARS_TOP}
615   echo "    - nginx_webshell_configuration" >> ${PILLARS_TOP}
616   echo "    - nginx_workbench2_configuration" >> ${PILLARS_TOP}
617   echo "    - nginx_workbench_configuration" >> ${PILLARS_TOP}
618   echo "    - logrotate_wb1" >> ${PILLARS_TOP}
619   echo "    - postgresql" >> ${PILLARS_TOP}
620
621   # We need to tweak the Nginx's pillar depending whether we want plan nginx or nginx+passenger
622   NGINX_INSTALL_SOURCE="install_from_phusionpassenger"
623   sed -i "s/__NGINX_INSTALL_SOURCE__/${NGINX_INSTALL_SOURCE}/g" ${P_DIR}/nginx_passenger.sls
624
625   if [ "${SSL_MODE}" = "lets-encrypt" ]; then
626     if [ "${USE_LETSENCRYPT_ROUTE53}" = "yes" ]; then
627       grep -q "aws_credentials" ${PILLARS_TOP} || echo "    - aws_credentials" >> ${PILLARS_TOP}
628     fi
629     grep -q "letsencrypt" ${PILLARS_TOP} || echo "    - letsencrypt" >> ${PILLARS_TOP}
630
631     hosts=("controller" "websocket" "workbench" "workbench2" "webshell" "keepproxy")
632     if [ ${USE_SINGLE_HOSTNAME} = "no" ]; then
633       hosts+=("download" "collections")
634     else
635       hosts+=("keepweb")
636     fi
637
638     for c in "${hosts[@]}"; do
639       # Are we in a single-host-single-hostname env?
640       if [ "${USE_SINGLE_HOSTNAME}" = "yes" ]; then
641         # Are we in a single-host-single-hostname env?
642         CERT_NAME=${HOSTNAME_EXT}
643       else
644         # We are in a multiple-hostnames env
645         CERT_NAME=${c}.${DOMAIN}
646       fi
647
648       # As the pillar differs whether we use LE or custom certs, we need to do a final edition on them
649       sed -i "s/__CERT_REQUIRES__/cmd: create-initial-cert-${CERT_NAME}*/g;
650               s#__CERT_PEM__#/etc/letsencrypt/live/${CERT_NAME}/fullchain.pem#g;
651               s#__CERT_KEY__#/etc/letsencrypt/live/${CERT_NAME}/privkey.pem#g" \
652       ${P_DIR}/nginx_${c}_configuration.sls
653     done
654   else
655     # Use custom certs (either dev mode or prod)
656     grep -q "extra_custom_certs" ${PILLARS_TOP} || echo "    - extra_custom_certs" >> ${PILLARS_TOP}
657     # And add the certs in the custom_certs pillar
658     echo "extra_custom_certs_dir: /srv/salt/certs" > ${P_DIR}/extra_custom_certs.sls
659     echo "extra_custom_certs:" >> ${P_DIR}/extra_custom_certs.sls
660
661     for c in controller websocket workbench workbench2 webshell keepweb keepproxy; do
662       # Are we in a single-host-single-hostname env?
663       if [ "${USE_SINGLE_HOSTNAME}" = "yes" ]; then
664         # Are we in a single-host-single-hostname env?
665         CERT_NAME=${HOSTNAME_EXT}
666       else
667         # We are in a multiple-hostnames env
668         CERT_NAME=${c}
669       fi
670
671       if [[ "$SSL_MODE" == "bring-your-own" ]]; then
672         copy_custom_cert ${CUSTOM_CERTS_DIR} ${CERT_NAME}
673       fi
674
675       grep -q ${CERT_NAME} ${P_DIR}/extra_custom_certs.sls || echo "  - ${CERT_NAME}" >> ${P_DIR}/extra_custom_certs.sls
676
677       # As the pillar differs whether we use LE or custom certs, we need to do a final edition on them
678       sed -i "s/__CERT_REQUIRES__/file: extra_custom_certs_${CERT_NAME}_cert_file_copy/g;
679               s#__CERT_PEM__#/etc/nginx/ssl/arvados-${CERT_NAME}.pem#g;
680               s#__CERT_KEY__#/etc/nginx/ssl/arvados-${CERT_NAME}.key#g" \
681       ${P_DIR}/nginx_${c}_configuration.sls
682     done
683   fi
684 else
685   # If we add individual roles, make sure we add the repo first
686   echo "    - arvados.repo" >> ${STATES_TOP}
687   # We add the extra_custom_certs state
688   grep -q "extra.custom_certs"    ${STATES_TOP} || echo "    - extra.custom_certs" >> ${STATES_TOP}
689   if [ "${SSL_KEY_ENCRYPTED}" = "yes" ]; then
690     grep -q "ssl_key_encrypted" ${STATES_TOP} || echo "    - extra.ssl_key_encrypted" >> ${STATES_TOP}
691   fi
692
693   # And we add the basic part for the certs pillar
694   if [ "${SSL_MODE}" != "lets-encrypt" ]; then
695     # And add the certs in the custom_certs pillar
696     echo "extra_custom_certs_dir: /srv/salt/certs" > ${P_DIR}/extra_custom_certs.sls
697     echo "extra_custom_certs:" >> ${P_DIR}/extra_custom_certs.sls
698     grep -q "extra_custom_certs" ${PILLARS_TOP} || echo "    - extra_custom_certs" >> ${PILLARS_TOP}
699   fi
700
701   # Prometheus state on all nodes due to the node exporter below
702   grep -q "\- prometheus$" ${STATES_TOP} || echo "    - prometheus" >> ${STATES_TOP}
703   # Prometheus node exporter pillar
704   grep -q "prometheus_node_exporter" ${PILLARS_TOP} || echo "    - prometheus_node_exporter" >> ${PILLARS_TOP}
705
706   for R in ${ROLES:-}; do
707     case "${R}" in
708       "database")
709         # States
710         grep -q "\- postgres$" ${STATES_TOP} || echo "    - postgres" >> ${STATES_TOP}
711         grep -q "extra.prometheus_pg_exporter" ${STATES_TOP} || echo "    - extra.prometheus_pg_exporter" >> ${STATES_TOP}
712         # Pillars
713         grep -q "postgresql" ${PILLARS_TOP} || echo "    - postgresql" >> ${PILLARS_TOP}
714         grep -q "prometheus_pg_exporter" ${PILLARS_TOP} || echo "    - prometheus_pg_exporter" >> ${PILLARS_TOP}
715       ;;
716       "monitoring")
717         ### Support files ###
718         GRAFANA_DASHBOARDS_DEST_DIR=/srv/salt/dashboards
719         mkdir -p "${GRAFANA_DASHBOARDS_DEST_DIR}"
720         rm -f "${GRAFANA_DASHBOARDS_DEST_DIR}"/*
721         # "ArvadosPromDataSource" is the hardcoded UID for Prometheus' datasource
722         # in Grafana.
723         for f in $(ls "${GRAFANA_DASHBOARDS_DIR}"/*.json); do
724           sed "s#__TLS_EXPIRATION_YELLOW__#${TLS_EXPIRATION_YELLOW}#g;
725                s#__TLS_EXPIRATION_GREEN__#${TLS_EXPIRATION_GREEN}#g;
726                s#\${DS_PROMETHEUS}#ArvadosPromDataSource#g" \
727           "${f}" > "${GRAFANA_DASHBOARDS_DEST_DIR}"/$(basename "${f}")
728         done
729
730         ### States ###
731         grep -q "\- nginx$" ${STATES_TOP} || echo "    - nginx" >> ${STATES_TOP}
732         grep -q "extra.nginx_prometheus_configuration" ${STATES_TOP} || echo "    - extra.nginx_prometheus_configuration" >> ${STATES_TOP}
733
734         grep -q "\- grafana$" ${STATES_TOP} || echo "    - grafana" >> ${STATES_TOP}
735         grep -q "extra.grafana_datasource" ${STATES_TOP} || echo "    - extra.grafana_datasource" >> ${STATES_TOP}
736         grep -q "extra.grafana_dashboards" ${STATES_TOP} || echo "    - extra.grafana_dashboards" >> ${STATES_TOP}
737         grep -q "extra.grafana_admin_user" ${STATES_TOP} || echo "    - extra.grafana_admin_user" >> ${STATES_TOP}
738
739         if [ "${SSL_MODE}" = "lets-encrypt" ]; then
740           grep -q "letsencrypt"     ${STATES_TOP} || echo "    - letsencrypt" >> ${STATES_TOP}
741           if [ "x${USE_LETSENCRYPT_ROUTE53:-}" = "xyes" ]; then
742             grep -q "aws_credentials" ${STATES_TOP} || echo "    - aws_credentials" >> ${STATES_TOP}
743           fi
744         elif [ "${SSL_MODE}" = "bring-your-own" ]; then
745           for SVC in grafana prometheus; do
746             copy_custom_cert ${CUSTOM_CERTS_DIR} ${SVC}
747           done
748         fi
749         ### Pillars ###
750         grep -q "prometheus_server" ${PILLARS_TOP} || echo "    - prometheus_server" >> ${PILLARS_TOP}
751         grep -q "grafana" ${PILLARS_TOP} || echo "    - grafana" >> ${PILLARS_TOP}
752         for SVC in grafana prometheus; do
753           grep -q "nginx_${SVC}_configuration" ${PILLARS_TOP} || echo "    - nginx_${SVC}_configuration" >> ${PILLARS_TOP}
754         done
755         grep -q "nginx_snippets" ${PILLARS_TOP} || echo "    - nginx_snippets" >> ${PILLARS_TOP}
756         if [ "${SSL_MODE}" = "lets-encrypt" ]; then
757           grep -q "letsencrypt"     ${PILLARS_TOP} || echo "    - letsencrypt" >> ${PILLARS_TOP}
758           for SVC in grafana prometheus; do
759             grep -q "letsencrypt_${SVC}_configuration" ${PILLARS_TOP} || echo "    - letsencrypt_${SVC}_configuration" >> ${PILLARS_TOP}
760             sed -i "s/__CERT_REQUIRES__/cmd: create-initial-cert-${SVC}.${DOMAIN}*/g;
761                     s#__CERT_PEM__#/etc/letsencrypt/live/${SVC}.${DOMAIN}/fullchain.pem#g;
762                     s#__CERT_KEY__#/etc/letsencrypt/live/${SVC}.${DOMAIN}/privkey.pem#g" \
763             ${P_DIR}/nginx_${SVC}_configuration.sls
764           done
765           if [ "${USE_LETSENCRYPT_ROUTE53}" = "yes" ]; then
766             grep -q "aws_credentials" ${PILLARS_TOP} || echo "    - aws_credentials" >> ${PILLARS_TOP}
767           fi
768         elif [ "${SSL_MODE}" = "bring-your-own" ]; then
769           grep -q "ssl_key_encrypted" ${PILLARS_TOP} || echo "    - ssl_key_encrypted" >> ${PILLARS_TOP}
770           for SVC in grafana prometheus; do
771             sed -i "s/__CERT_REQUIRES__/file: extra_custom_certs_${SVC}_cert_file_copy/g;
772                     s#__CERT_PEM__#/etc/nginx/ssl/arvados-${SVC}.pem#g;
773                     s#__CERT_KEY__#/etc/nginx/ssl/arvados-${SVC}.key#g" \
774               ${P_DIR}/nginx_${SVC}_configuration.sls
775             grep -q ${SVC} ${P_DIR}/extra_custom_certs.sls || echo "  - ${SVC}" >> ${P_DIR}/extra_custom_certs.sls
776           done
777         fi
778       ;;
779       "balancer")
780         ### States ###
781         grep -q "\- nginx$" ${STATES_TOP} || echo "    - nginx" >> ${STATES_TOP}
782
783         if [ "${SSL_MODE}" = "lets-encrypt" ]; then
784           grep -q "letsencrypt"     ${STATES_TOP} || echo "    - letsencrypt" >> ${STATES_TOP}
785           if [ "x${USE_LETSENCRYPT_ROUTE53:-}" = "xyes" ]; then
786             grep -q "aws_credentials" ${STATES_TOP} || echo "    - aws_credentials" >> ${STATES_TOP}
787           fi
788         elif [ "${SSL_MODE}" = "bring-your-own" ]; then
789           copy_custom_cert ${CUSTOM_CERTS_DIR} ${R}
790         fi
791
792         ### Pillars ###
793         grep -q "nginx_${R}_configuration" ${PILLARS_TOP} || echo "    - nginx_${R}_configuration" >> ${PILLARS_TOP}
794
795         if [ "${SSL_MODE}" = "lets-encrypt" ]; then
796           grep -q "letsencrypt"     ${PILLARS_TOP} || echo "    - letsencrypt" >> ${PILLARS_TOP}
797
798           grep -q "letsencrypt_${R}_configuration" ${PILLARS_TOP} || echo "    - letsencrypt_${R}_configuration" >> ${PILLARS_TOP}
799           sed -i "s/__CERT_REQUIRES__/cmd: create-initial-cert-${ROLE2NODES['balancer']}*/g;
800                   s#__CERT_PEM__#/etc/letsencrypt/live/${ROLE2NODES['balancer']}/fullchain.pem#g;
801                   s#__CERT_KEY__#/etc/letsencrypt/live/${ROLE2NODES['balancer']}/privkey.pem#g" \
802           ${P_DIR}/nginx_${R}_configuration.sls
803
804           if [ "${USE_LETSENCRYPT_ROUTE53}" = "yes" ]; then
805             grep -q "aws_credentials" ${PILLARS_TOP} || echo "    - aws_credentials" >> ${PILLARS_TOP}
806           fi
807         elif [ "${SSL_MODE}" = "bring-your-own" ]; then
808           grep -q "ssl_key_encrypted" ${PILLARS_TOP} || echo "    - ssl_key_encrypted" >> ${PILLARS_TOP}
809           sed -i "s/__CERT_REQUIRES__/file: extra_custom_certs_${R}_cert_file_copy/g;
810                   s#__CERT_PEM__#/etc/nginx/ssl/arvados-${R}.pem#g;
811                   s#__CERT_KEY__#/etc/nginx/ssl/arvados-${R}.key#g" \
812             ${P_DIR}/nginx_${R}_configuration.sls
813           grep -q "${R}" ${P_DIR}/extra_custom_certs.sls || echo "  - ${R}" >> ${P_DIR}/extra_custom_certs.sls
814         fi
815       ;;
816       "controller")
817         ### States ###
818         grep -q "    - logrotate" ${STATES_TOP} || echo "    - logrotate" >> ${STATES_TOP}
819         if grep -q "    - nginx.*$" ${STATES_TOP}; then
820           sed -i s/"^    - nginx.*$"/"    - nginx.passenger"/g ${STATES_TOP}
821         else
822           echo "    - nginx.passenger" >> ${STATES_TOP}
823         fi
824         echo "    - extra.passenger_rvm" >> ${STATES_TOP}
825         grep -q "^    - postgres\\.client$" ${STATES_TOP} || echo "    - postgres.client" >> ${STATES_TOP}
826
827         ### If we don't install and run LE before arvados-api-server, it fails and breaks everything
828         ### after it. So we add this here as we are, after all, sharing the host for api and controller
829         if [ "${ENABLE_BALANCER}" == "no" ]; then
830           if [ "${SSL_MODE}" = "lets-encrypt" ]; then
831             if [ "x${USE_LETSENCRYPT_ROUTE53:-}" = "xyes" ]; then
832               grep -q "aws_credentials" ${STATES_TOP} || echo "    - aws_credentials" >> ${STATES_TOP}
833             fi
834             grep -q "letsencrypt"     ${STATES_TOP} || echo "    - letsencrypt" >> ${STATES_TOP}
835           elif [ "${SSL_MODE}" = "bring-your-own" ]; then
836             copy_custom_cert ${CUSTOM_CERTS_DIR} ${R}
837             grep -q controller ${P_DIR}/extra_custom_certs.sls || echo "  - controller" >> ${P_DIR}/extra_custom_certs.sls
838           fi
839         fi
840         grep -q "arvados.api" ${STATES_TOP} || echo "    - arvados.api" >> ${STATES_TOP}
841         grep -q "arvados.controller" ${STATES_TOP} || echo "    - arvados.controller" >> ${STATES_TOP}
842
843         ### Pillars ###
844         grep -q "logrotate_api" ${PILLARS_TOP}            || echo "    - logrotate_api" >> ${PILLARS_TOP}
845         grep -q "aws_credentials" ${PILLARS_TOP}          || echo "    - aws_credentials" >> ${PILLARS_TOP}
846         grep -q "postgresql" ${PILLARS_TOP}               || echo "    - postgresql" >> ${PILLARS_TOP}
847         grep -q "nginx_passenger" ${PILLARS_TOP}          || echo "    - nginx_passenger" >> ${PILLARS_TOP}
848         grep -q "nginx_snippets" ${PILLARS_TOP}           || echo "    - nginx_snippets" >> ${PILLARS_TOP}
849         grep -q "nginx_api_configuration" ${PILLARS_TOP} || echo "    - nginx_api_configuration" >> ${PILLARS_TOP}
850         grep -q "nginx_controller_configuration" ${PILLARS_TOP} || echo "    - nginx_controller_configuration" >> ${PILLARS_TOP}
851
852         if [ "${ENABLE_BALANCER}" == "no" ]; then
853           if [ "${SSL_MODE}" = "lets-encrypt" ]; then
854             if [ "${USE_LETSENCRYPT_ROUTE53}" = "yes" ]; then
855               grep -q "aws_credentials" ${PILLARS_TOP} || echo "    - aws_credentials" >> ${PILLARS_TOP}
856             fi
857
858             grep -q "letsencrypt"     ${PILLARS_TOP} || echo "    - letsencrypt" >> ${PILLARS_TOP}
859             grep -q "letsencrypt_${R}_configuration" ${PILLARS_TOP} || echo "    - letsencrypt_${R}_configuration" >> ${PILLARS_TOP}
860             sed -i "s/__CERT_REQUIRES__/cmd: create-initial-cert-${R}.${DOMAIN}*/g;
861                     s#__CERT_PEM__#/etc/letsencrypt/live/${R}.${DOMAIN}/fullchain.pem#g;
862                     s#__CERT_KEY__#/etc/letsencrypt/live/${R}.${DOMAIN}/privkey.pem#g" \
863             ${P_DIR}/nginx_${R}_configuration.sls
864           else
865             grep -q "ssl_key_encrypted" ${PILLARS_TOP} || echo "    - ssl_key_encrypted" >> ${PILLARS_TOP}
866             sed -i "s/__CERT_REQUIRES__/file: extra_custom_certs_${R}_cert_file_copy/g;
867                     s#__CERT_PEM__#/etc/nginx/ssl/arvados-${R}.pem#g;
868                     s#__CERT_KEY__#/etc/nginx/ssl/arvados-${R}.key#g" \
869             ${P_DIR}/nginx_${R}_configuration.sls
870             grep -q ${R} ${P_DIR}/extra_custom_certs.sls || echo "  - ${R}" >> ${P_DIR}/extra_custom_certs.sls
871           fi
872         fi
873         # We need to tweak the Nginx's pillar depending whether we want plain nginx or nginx+passenger
874         NGINX_INSTALL_SOURCE="install_from_phusionpassenger"
875         sed -i "s/__NGINX_INSTALL_SOURCE__/${NGINX_INSTALL_SOURCE}/g" ${P_DIR}/nginx_passenger.sls
876       ;;
877       "websocket" | "workbench" | "workbench2" | "webshell" | "keepweb" | "keepproxy")
878         ### States ###
879         grep -q "\- nginx$" ${STATES_TOP} || echo "    - nginx" >> ${STATES_TOP}
880
881         if [ "${SSL_MODE}" = "lets-encrypt" ]; then
882           if [ "x${USE_LETSENCRYPT_ROUTE53:-}" = "xyes" ]; then
883             grep -q "aws_credentials" ${STATES_TOP} || echo "    - aws_credentials" >> ${STATES_TOP}
884           fi
885           grep -q "letsencrypt"     ${STATES_TOP} || echo "    - letsencrypt" >> ${STATES_TOP}
886         else
887           # Use custom certs, special case for keepweb
888           if [ ${R} = "keepweb" ]; then
889             if [ "${SSL_MODE}" = "bring-your-own" ]; then
890               copy_custom_cert ${CUSTOM_CERTS_DIR} download
891               copy_custom_cert ${CUSTOM_CERTS_DIR} collections
892             fi
893           else
894             if [ "${SSL_MODE}" = "bring-your-own" ]; then
895               copy_custom_cert ${CUSTOM_CERTS_DIR} ${R}
896             fi
897           fi
898         fi
899
900         # webshell role is just a nginx vhost, so it has no state
901         # workbench role is deprecated since 2.7.0
902         if [[ "${R}" != "webshell" && "${R}" != "workbench" ]]; then
903           grep -q "arvados.${R}" ${STATES_TOP} || echo "    - arvados.${R}" >> ${STATES_TOP}
904         fi
905
906         ### Pillars ###
907         grep -q "nginx_${R}_configuration" ${PILLARS_TOP} || echo "    - nginx_${R}_configuration" >> ${PILLARS_TOP}
908         grep -q "nginx_snippets" ${PILLARS_TOP} || echo "    - nginx_snippets" >> ${PILLARS_TOP}
909         # Special case for keepweb
910         if [ ${R} = "keepweb" ]; then
911           grep -q "nginx_download_configuration" ${PILLARS_TOP} || echo "    - nginx_download_configuration" >> ${PILLARS_TOP}
912           grep -q "nginx_collections_configuration" ${PILLARS_TOP} || echo "    - nginx_collections_configuration" >> ${PILLARS_TOP}
913         fi
914
915         if [ "${SSL_MODE}" = "lets-encrypt" ]; then
916           if [ "${USE_LETSENCRYPT_ROUTE53}" = "yes" ]; then
917             grep -q "aws_credentials" ${PILLARS_TOP} || echo "    - aws_credentials" >> ${PILLARS_TOP}
918           fi
919           grep -q "letsencrypt"     ${PILLARS_TOP} || echo "    - letsencrypt" >> ${PILLARS_TOP}
920           grep -q "letsencrypt_${R}_configuration" ${PILLARS_TOP} || echo "    - letsencrypt_${R}_configuration" >> ${PILLARS_TOP}
921
922           # As the pillar differ whether we use LE or custom certs, we need to do a final edition on them
923           # Special case for keepweb
924           if [ ${R} = "keepweb" ]; then
925             for kwsub in download collections; do
926               sed -i "s/__CERT_REQUIRES__/cmd: create-initial-cert-${kwsub}.${DOMAIN}*/g;
927                       s#__CERT_PEM__#/etc/letsencrypt/live/${kwsub}.${DOMAIN}/fullchain.pem#g;
928                       s#__CERT_KEY__#/etc/letsencrypt/live/${kwsub}.${DOMAIN}/privkey.pem#g" \
929               ${P_DIR}/nginx_${kwsub}_configuration.sls
930             done
931           else
932             sed -i "s/__CERT_REQUIRES__/cmd: create-initial-cert-${R}.${DOMAIN}*/g;
933                     s#__CERT_PEM__#/etc/letsencrypt/live/${R}.${DOMAIN}/fullchain.pem#g;
934                     s#__CERT_KEY__#/etc/letsencrypt/live/${R}.${DOMAIN}/privkey.pem#g" \
935             ${P_DIR}/nginx_${R}_configuration.sls
936           fi
937         else
938           grep -q "ssl_key_encrypted" ${PILLARS_TOP} || echo "    - ssl_key_encrypted" >> ${PILLARS_TOP}
939           # As the pillar differ whether we use LE or custom certs, we need to do a final edition on them
940           # Special case for keepweb
941           if [ ${R} = "keepweb" ]; then
942             for kwsub in download collections; do
943               sed -i "s/__CERT_REQUIRES__/file: extra_custom_certs_${kwsub}_cert_file_copy/g;
944                       s#__CERT_PEM__#/etc/nginx/ssl/arvados-${kwsub}.pem#g;
945                       s#__CERT_KEY__#/etc/nginx/ssl/arvados-${kwsub}.key#g" \
946               ${P_DIR}/nginx_${kwsub}_configuration.sls
947               grep -q ${kwsub} ${P_DIR}/extra_custom_certs.sls || echo "  - ${kwsub}" >> ${P_DIR}/extra_custom_certs.sls
948             done
949           else
950             sed -i "s/__CERT_REQUIRES__/file: extra_custom_certs_${R}_cert_file_copy/g;
951                     s#__CERT_PEM__#/etc/nginx/ssl/arvados-${R}.pem#g;
952                     s#__CERT_KEY__#/etc/nginx/ssl/arvados-${R}.key#g" \
953             ${P_DIR}/nginx_${R}_configuration.sls
954             grep -q ${R} ${P_DIR}/extra_custom_certs.sls || echo "  - ${R}" >> ${P_DIR}/extra_custom_certs.sls
955           fi
956         fi
957         # We need to tweak the Nginx's pillar depending whether we want plain nginx or nginx+passenger
958         sed -i "s/__NGINX_INSTALL_SOURCE__/${NGINX_INSTALL_SOURCE}/g" ${P_DIR}/nginx_passenger.sls
959       ;;
960       "shell")
961         # States
962         echo "    - extra.shell_sudo_passwordless" >> ${STATES_TOP}
963         echo "    - extra.shell_cron_add_login_sync" >> ${STATES_TOP}
964         grep -q "docker" ${STATES_TOP}       || echo "    - docker.software" >> ${STATES_TOP}
965         grep -q "arvados.${R}" ${STATES_TOP} || echo "    - arvados.${R}" >> ${STATES_TOP}
966         # Pillars
967         grep -q "docker" ${PILLARS_TOP}       || echo "    - docker" >> ${PILLARS_TOP}
968       ;;
969       "dispatcher" | "keepbalance" | "keepstore")
970         # States
971         grep -q "arvados.${R}" ${STATES_TOP} || echo "    - arvados.${R}" >> ${STATES_TOP}
972         # Pillars
973         # ATM, no specific pillar needed
974       ;;
975       *)
976         echo "Unknown role ${R}"
977         exit 1
978       ;;
979     esac
980   done
981 fi
982
983 if [ "${DUMP_CONFIG}" = "yes" ]; then
984   # We won't run the rest of the script because we're just dumping the config
985   exit 0
986 fi
987
988 # Now run the install
989 salt-call --state-output=mixed --local state.apply -l ${LOG_LEVEL}
990
991 # Finally, make sure that /etc/hosts is not overwritten on reboot
992 if [ -d /etc/cloud/cloud.cfg.d ]; then
993   # TODO: will this work on CentOS?
994   sed -i 's/^manage_etc_hosts: true/#manage_etc_hosts: true/g' /etc/cloud/cloud.cfg.d/*
995 fi
996
997 # Leave a copy of the Arvados CA so the user can copy it where it's required
998 if [ "${SSL_MODE}" = "self-signed" ]; then
999   echo "Copying the Arvados CA certificate '${DOMAIN}-arvados-snakeoil-ca.crt' to the installer dir, so you can import it"
1000   if [ "x${VAGRANT:-}" = "xyes" ]; then
1001     cp /etc/ssl/certs/arvados-snakeoil-ca.pem /vagrant/${DOMAIN}-arvados-snakeoil-ca.pem
1002   else
1003     cp /etc/ssl/certs/arvados-snakeoil-ca.pem ${SCRIPT_DIR}/${DOMAIN}-arvados-snakeoil-ca.crt
1004   fi
1005 fi
1006
1007 if [ "x${VAGRANT:-}" = "xyes" ]; then
1008     # If running in a vagrant VM, also add default user to docker group
1009     echo "Adding the vagrant user to the docker group"
1010     usermod -a -G docker vagrant
1011 fi
1012
1013 # Test that the installation finished correctly
1014 if [ "x${TEST:-}" = "xyes" ]; then
1015   cd ${T_DIR}
1016   # If we use RVM, we need to run this with it, or most ruby commands will fail
1017   RVM_EXEC=""
1018   if [ -x /usr/local/rvm/bin/rvm-exec ]; then
1019     RVM_EXEC="/usr/local/rvm/bin/rvm-exec"
1020   fi
1021   ${RVM_EXEC} ./run-test.sh
1022 fi